// Header File
// Created 11/21/2010; 7:03:11 AM

//******************************************************************************
//
// Project:         Jumpman 89
//
// file name:       jm_platforms.h
//
// author:          David Randall "Ranman" 
//                  derandall99@gmail.com
//
// notes::          Jumpman was originally created by Randy Glover for the
//                  Atari 400, Commodore 64, IBM PCjr, and Apple II in 1982
//
//******************************************************************************


#ifndef _jm_platforms_h
#define _jm_platforms_h

#include "BasicTypes.h"

#include "jm_jumpman.h"
#include "jm_objects.h"


extern int2 skip_rope_check;
extern int2 skip_chain_check;


void ConstructPlatformLevel(void);
void DrawPlatformPiece(uint1 value, uint1 flags, int2 x, int2 y);
void ModifyPlatformPiece(uint1 value, uint1 new_flags, int2 x, int2 y);
void DrawPlatformLevel(void);
bool CheckJumpmanLadder(void);
bool CheckJumpmanLadderRow(int2 y1, int2 y2);
bool CheckJumpmanGirderRow(int2 y1, int2 y2);
bool CheckJumpmanChain(void);
bool CheckJumpmanRope(void);
void CheckPlatformInteractions(DIR_Type direction);
void Illuminate();
void Hotfoot();

#endif
