// Header File
// Created 3/5/2005; 9:55:19 AM

//******************************************************************************
//
// file name:       KeyUtils.h
//
// author:          David Randall "Ranman" 
//                  derandall99@gmail.com
//
//******************************************************************************


#ifndef _KeyUtils
#define _KeyUtils

#include "BasicTypes.h"

#define KBD_Repeat   1
#define KBD_NoRepeat 0

#define KBD_AllowDiagonalDirection 0

#define TI_89_CALC

typedef enum
{
	KBD_NoKey,

	KBD_Esc, KBD_Enter, KBD_Apps,

	KBD_Up, KBD_Right, KBD_Down, KBD_Left,
	KBD_UpRight, KBD_DownRight, KBD_DownLeft, KBD_UpLeft,

	KBD_F1, KBD_F2, KBD_F3, KBD_F4, KBD_F5, KBD_F6, KBD_F7, KBD_F8,
	KBD_Home, KBD_Mode, KBD_Catalog, KBD_Backspace, KBD_Clear,

	KBD_Power,

#ifdef TI_89_CALC
	KBD_Negate = 32,
	KBD_Space = 32,

	KBD_Equals = 65, KBD_OpenPar, KBD_ClosePar, KBD_Comma, KBD_Divide,
	KBD_Or,  KBD_7, KBD_8, KBD_9, KBD_Multiply,
	KBD_EE,  KBD_4, KBD_5, KBD_6, KBD_Minus,
	KBD_Sto, KBD_1, KBD_2, KBD_3, KBD_T, KBD_Plus,
	KBD_0, KBD_Decimal, KBD_X, KBD_Y, KBD_Z,
	
	KBD_A = 65,	KBD_B, KBD_C, KBD_D, KBD_E,
	KBD_F, KBD_G, KBD_H, KBD_I, KBD_J,
	KBD_K, KBD_L, KBD_M, KBD_N, KBD_O,
	KBD_P, KBD_Q, KBD_R, KBD_S, KBD_Ta, KBD_U,
	KBD_V, KBD_W, KBD_Xa, KBD_Ya, KBD_Za,
#else
	KBD_Negate, KBD_Equals, KBD_EE, KBD_Sto, KBD_Or,

	KBD_Space = 32,

	KBD_Ln, KBD_Sin, KBD_Cos, KBD_Tan, KBD_Theta,

	KBD_OpenPar = 40, KBD_ClosePar, KBD_Multiply, KBD_Plus,
	KBD_Comma, KBD_Minus, KBD_Decimal, KBD_Divide,

	KBD_0 = 48, KBD_1, KBD_2, KBD_3, KBD_4,
	KBD_5, KBD_6, KBD_7, KBD_8, KBD_9,

	KBD_A = 65,	KBD_B, KBD_C, KBD_D, KBD_E,
	KBD_F, KBD_G, KBD_H, KBD_I, KBD_J,
	KBD_K, KBD_L, KBD_M, KBD_N, KBD_O,
	KBD_P, KBD_Q, KBD_R, KBD_S, KBD_T, KBD_U,
	KBD_V, KBD_W, KBD_X, KBD_Y, KBD_Z,
#endif

	KBD_2nd      = 0x1000,
	KBD_Diamond  = 0x2000,
	KBD_Shift    = 0x4000,
	KBD_Alpha    = 0x8000

} KeyboardInput;


KeyboardInput GetKeyPress(int2 allowRepeat);
KeyboardInput GetFunctionKeyPress(int2 allowRepeat);
KeyboardInput GetDirectionKeyPress(int2 allowRepeat);
KeyboardInput GetModifierKeyPress(int2 allowRepeat);

int2 ConvertKeyPressToNumber(KeyboardInput keyPress);



#endif // _KeyboardUtils