| C prototype:
| short IsVTI(void);

|=============================================================================
| VTI detection routine (by Julien Muchembled)
|
| this routine utilizes a bug in VTI: you can set even non-existing flags in
| the status register and query them later!
|=============================================================================

.data
.globl IsVTI
.even

|IsVTI:
|    trap   #12         | enter supervisor mode. returns old (%sr) in %d0.w
|    move.w #0x3000,%sr | set a non-existing flag in %sr (but keep s-flag !!)
|    swap   %d0         | save %d0.w content in upper part of %d0
|    move.w %sr,%d0     | get %sr content and check for non-existing flag
|    btst   #12,%d0     | this non-existing flag can only be set on the VTI
|    bne    __VTI
|    swap   %d0         | restore old %sr content and return 0
|    move.w %d0,%sr
|    moveq  #0,%d0
|    rts
|__VTI:
|    swap   %d0         | restore old %sr content and return 1
|    move.w %d0,%sr
|    moveq  #1,%d0
|    rts


    |--------------------------------------------------------------------------
    | check for VTI (trick suggested by Julien Muchembled)
    |--------------------------------------------------------------------------
IsVTI:
	trap     #12         | enter supervisor mode. returns old (%sr) in %d0.w
	move.w   #0x3000,%sr | set a non-existing flag in %sr (but keep s-flag)
	move.w   %sr,%d1     | get %sr content and check for non-existing flag
	move.w   %d0,%sr     | restore old %sr content
	lsl.w    #3,%d1      | the non-existing 0x1000 can only be set on VTI
	bpl.s    __VTI       | flag not set -> no VTI
	moveq.l  #1,%d0      | set %d0 to 1 (HW1)
	rts                  | return 1
__VTI:
    |--------------------------------------------------------------------------
    | HW detected
    |--------------------------------------------------------------------------
	moveq.l  #0,%d0      | set %d0 to 1 (HW1)
	rts                  | return 1
	
	